package com.company.testingjmix.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "SECOND_", indexes = {
        @Index(name = "IDX_SECOND__FIRST", columnList = "FIRST_ID")
})
@Entity(name = "Second_")
public class Second {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "FIELD")
    private String field;

    @JoinTable(name = "SECOND_THIRD_LINK",
            joinColumns = @JoinColumn(name = "SECOND_ID", referencedColumnName = "ID"),
            inverseJoinColumns = @JoinColumn(name = "THIRD_ID", referencedColumnName = "ID"))
    @ManyToMany
    private List<Third> third;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "FIRST_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private First first;

    public String getField() {
        return field;
    }

    public void setField(String field) {
        this.field = field;
    }

    public List<Third> getThird() {
        return third;
    }

    public void setThird(List<Third> third) {
        this.third = third;
    }

    public First getFirst() {
        return first;
    }

    public void setFirst(First first) {
        this.first = first;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}